/* $Id: national.h,v 3.1 1994/02/25 02:33:38 ppessi Exp $
 *
 * national.h --- special national fonts and keymappings
 *
 * Author: ppessi <Pekka.Pessi@hut.fi>
 *
 * Copyright (c) 1993 Pekka Pessi
 *
 * Created      : Mon Mar 29 06:38:37 1993 ppessi
 * Last modified: Fri Feb 25 02:09:58 1994 ppessi
 *
 */

#define MAX_NATIONS 31
#define CHARSETSIZE 256

/* national_kmap provides mapping from 
 * the ascii codes to the national character codes
 */
extern unsigned char national_table[CHARSETSIZE];

/* national_kmap provides mapping from 
 * the keyboard codes to the national character codes
 */
extern unsigned char national_kmap[CHARSETSIZE];

struct nation {
  char *n_name;
  char *n_kmapname;	/* name of the kmap resource */
  void *n_kmap;		/* pointer to the kmap resource */
  char *n_patches;	/* mapping between Latin1 and national code */
};

extern struct nation nations[MAX_NATIONS];
extern struct nation *used_nation;

void initnation(unsigned int n);
void initnation_byname(char *name); /* where is the C++? ;) */
void initnations(void);
void deinitnations(void);


